package ru.amse.cat.evlarchick.textstructure;

import java.util.List;
import java.util.Iterator;
import java.io.Reader;

public interface ITextStructure {

    public abstract List<ISegmentWithTranslation> getSegments();

    public abstract List<ISegment> getDeadZones();

    public abstract void addDeadZone(ISegment current);

    public abstract void addSegmentWithTranslation(ISegmentWithTranslation current);

    public abstract Reader getTranslationReader();

    public abstract String getOriginalText();

    public abstract boolean isIndicesUseable(ISegment segment, int start, int end);

    public abstract ISegment getSegmentByIndex(int index);

    public abstract void setText(String s);

    public abstract List<ISegment> getCommonSegmentList();
}