package ru.amse.cat.evlarchick.ui;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.*;

public class FindDialog extends JDialog {
    public static int FIND = 0;
    public static int REPLACE = 1;

    private Color myFColor = Color.PINK;
    private Color myBColor = Color.DARK_GRAY;
    private Color myButtonColor = Color.DARK_GRAY;

    private JTextField myTextToFind;
    private JTextField myReplaceWith;

    public FindDialog(JFrame owner, final int policy) {
        super(owner);
        myTextToFind = new JTextField(15);
        myTextToFind.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));

        myReplaceWith = new JTextField(15);
        myReplaceWith.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));

        JLabel findLabel = new JLabel("Text to find");
        findLabel.setForeground(myFColor);
        findLabel.setBackground(myBColor);
        findLabel.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));

        JLabel replaceLabel = new JLabel("Replace with");
        replaceLabel.setForeground(myFColor);
        replaceLabel.setBackground(myBColor);
        replaceLabel.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));

        if (policy == FIND) {
            replaceLabel.setEnabled(false);
            myReplaceWith.setEnabled(false);
        }

        Dimension dimesion = new Dimension(90, 25);
        JButton findButton = new JButton("Find");
        findButton.setForeground(myFColor);
        findButton.setBackground(myButtonColor);
        findButton.setPreferredSize(dimesion);

        JButton cancelButton = new JButton("Cancel");
        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ae) {
                dispose();
            }
        });
        cancelButton.setForeground(myFColor);
        cancelButton.setBackground(myButtonColor);
        cancelButton.setPreferredSize(dimesion);

        JCheckBox regular = new JCheckBox("Regular Expression");
        regular.setForeground(myFColor);
        regular.setBackground(myBColor);
        //regular.setPreferredSize(new Dimension (20, 90));

        JPanel textPanel = new JPanel();
        textPanel.setLayout(new GridLayout(2, 2, 0, 10));
        textPanel.add(findLabel);
        textPanel.add(myTextToFind);
        textPanel.add(replaceLabel);
        textPanel.add(myReplaceWith);
        textPanel.setBorder(BorderFactory.createEmptyBorder(15, 10, 10, 10));
        textPanel.setBackground(myBColor);

        JPanel buttonPanel = new JPanel();
        buttonPanel.add(findButton, BorderLayout.EAST);
        buttonPanel.add(cancelButton, BorderLayout.EAST);
        buttonPanel.setBorder(BorderFactory.createEmptyBorder(5,10,5,10));
        buttonPanel.setBackground(myBColor);

        final JRadioButton segment = new JRadioButton("With translation");
        segment.setBackground(myBColor);
        segment.setForeground(myFColor);
        segment.setSelected(true);
        final JRadioButton deadZone = new JRadioButton("Dead Zone");
        deadZone.setBackground(myBColor);
        deadZone.setForeground(myFColor);
        ButtonGroup bg = new ButtonGroup();
        bg.add(segment);
        bg.add(deadZone);

        JPanel radioPanel = new JPanel(new GridLayout(1, 3));
        radioPanel.add(segment);
        radioPanel.add(deadZone);
        radioPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(5,5,5,5),
                BorderFactory.createCompoundBorder(
                        BorderFactory.createTitledBorder(BorderFactory.createLineBorder(myFColor), "Segment type", TitledBorder.DEFAULT_JUSTIFICATION,
                                TitledBorder.DEFAULT_POSITION, null, myFColor),
                        BorderFactory.createEmptyBorder(5, 10, 5, 10))));
        radioPanel.setBackground(myBColor);

        JPanel mainPanel = new JPanel(new BorderLayout());
        mainPanel.add(textPanel, BorderLayout.NORTH);
        mainPanel.add(radioPanel, BorderLayout.CENTER);
        mainPanel.add(buttonPanel, BorderLayout.SOUTH);
        mainPanel.setBackground(myBColor);

        findButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ae) {
                if (policy == FIND) {
                    if (!segment.isSelected()) {
                        UIManager.getInstance().processFind(myTextToFind.getText(), true);
                    } else {
                        UIManager.getInstance().processFind(myTextToFind.getText(), false);
                    }
                } else {
                    UIManager.getInstance().processReplace(myTextToFind.getText(),
                            myReplaceWith.getText());
                }
                dispose();
            }
        });


        setTitle("Find...");
        setModal(true);
        setResizable(false);
        setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
        setContentPane(mainPanel);
        pack();
    }
}
